diff --git a/content/app/content_main_runner.cc b/content/app/content_main_runner.cc
index b59c95a..032aa3e 100644
--- a/content/app/content_main_runner.cc
+++ b/content/app/content_main_runner.cc
@@ -32,6 +32,9 @@
 #include "content/common/set_process_title.h"
 #include "content/common/url_schemes.h"
 #include "content/gpu/in_process_gpu_thread.h"
+#if defined(USE_GSTREAMER)
+#include "content/media/in_process_media_thread.h"
+#endif
 #include "content/public/app/content_main.h"
 #include "content/public/app/content_main_delegate.h"
 #include "content/public/app/startup_helper_win.h"
@@ -67,6 +70,9 @@
 #if !defined(OS_IOS)
 #include "content/app/mojo/mojo_init.h"
 #include "content/browser/gpu/gpu_process_host.h"
+#if defined(USE_GSTREAMER)
+#include "content/browser/media/media_process_host.h"
+#endif
 #include "content/browser/renderer_host/render_process_host_impl.h"
 #include "content/browser/utility_process_host_impl.h"
 #include "content/public/plugin/content_plugin_client.h"
@@ -118,6 +124,9 @@ int tc_set_new_mode(int mode);
 
 namespace content {
 extern int GpuMain(const content::MainFunctionParams&);
+#if defined(USE_GSTREAMER)
+extern int MediaMain(const content::MainFunctionParams&);
+#endif
 #if defined(ENABLE_PLUGINS)
 #if !defined(OS_LINUX)
 extern int PluginMain(const content::MainFunctionParams&);
@@ -325,6 +334,10 @@ static void RegisterMainThreadFactories() {
       CreateInProcessRendererThread);
   GpuProcessHost::RegisterGpuMainThreadFactory(
       CreateInProcessGpuThread);
+#if defined(USE_GSTREAMER)
+  MediaProcessHost::RegisterMediaMainThreadFactory(
+      CreateInProcessMediaThread);
+#endif
 #else
   base::CommandLine& command_line = *base::CommandLine::ForCurrentProcess();
   if (command_line.HasSwitch(switches::kSingleProcess)) {
@@ -335,6 +348,12 @@ static void RegisterMainThreadFactories() {
     LOG(FATAL) <<
         "--in-process-gpu is not supported in chrome multiple dll browser.";
   }
+#if defined(USE_GSTREAMER)
+  if (command_line.HasSwitch(switches::kInProcessMedia)) {
+      LOG(FATAL) <<
+          "--in-process-media is not supported in chrome multiple dll browser.";
+  }
+#endif
 #endif  // !CHROME_MULTIPLE_DLL_BROWSER && !CHROME_MULTIPLE_DLL_CHILD
 }
 
@@ -360,6 +379,9 @@ int RunNamedProcessTypeMain(
     { switches::kUtilityProcess,     UtilityMain },
     { switches::kRendererProcess,    RendererMain },
     { switches::kGpuProcess,         GpuMain },
+#if defined(USE_GSTREAMER)
+    { switches::kMediaProcess,       MediaMain },
+#endif
 #endif  // !CHROME_MULTIPLE_DLL_BROWSER
   };
 
diff --git a/content/browser/browser_main_loop.cc b/content/browser/browser_main_loop.cc
index b0fa2c0..11aadf2 100644
--- a/content/browser/browser_main_loop.cc
+++ b/content/browser/browser_main_loop.cc
@@ -128,6 +128,11 @@
 #include <glib-object.h>
 #endif
 
+#if defined(USE_GSTREAMER)
+#include "content/browser/media/media_data_manager_impl.h"
+#include "content/browser/media/media_process_host.h"
+#endif
+
 #if defined(OS_LINUX) && defined(USE_UDEV)
 #include "content/browser/device_monitor_udev.h"
 #elif defined(OS_MACOSX) && !defined(OS_IOS)
@@ -1223,6 +1228,20 @@ int BrowserMainLoop::BrowserThreadsStarted() {
                    CAUSE_FOR_GPU_LAUNCH_BROWSER_STARTUP));
   }
 
+#if defined(USE_GSTREAMER)
+  MediaDataManagerImpl::GetInstance()->Initialize();
+
+  if (!UsingInProcessMedia()) {
+    TRACE_EVENT_INSTANT0("media", "Post task to launch media process",
+                         TRACE_EVENT_SCOPE_THREAD);
+    BrowserThread::PostTask(
+        BrowserThread::IO, FROM_HERE,
+        base::Bind(base::IgnoreResult(&MediaProcessHost::Get),
+                   MediaProcessHost::MEDIA_PROCESS_KIND_SANDBOXED,
+                   CAUSE_FOR_MEDIA_LAUNCH_BROWSER_STARTUP));
+  }
+#endif
+
 #if defined(OS_MACOSX)
   ThemeHelperMac::GetInstance();
   SystemHotkeyHelperMac::GetInstance()->DeferredLoadSystemHotkeys();
@@ -1245,6 +1264,13 @@ bool BrowserMainLoop::UsingInProcessGpu() const {
          parsed_command_line_.HasSwitch(switches::kInProcessGPU);
 }
 
+#if defined(USE_GSTREAMER)
+bool BrowserMainLoop::UsingInProcessMedia() const {
+  return parsed_command_line_.HasSwitch(switches::kSingleProcess) ||
+         parsed_command_line_.HasSwitch(switches::kInProcessMedia);
+}
+#endif
+
 bool BrowserMainLoop::InitializeToolkit() {
   TRACE_EVENT0("startup", "BrowserMainLoop::InitializeToolkit");
   TRACK_SCOPED_REGION("Startup", "BrowserMainLoop::InitializeToolkit");
diff --git a/content/browser/browser_main_loop.h b/content/browser/browser_main_loop.h
index 14478ec..8d80fd7 100644
--- a/content/browser/browser_main_loop.h
+++ b/content/browser/browser_main_loop.h
@@ -150,6 +150,9 @@ class CONTENT_EXPORT BrowserMainLoop {
   void EndStartupTracing();
 
   bool UsingInProcessGpu() const;
+#if defined(USE_GSTREAMER)
+  bool UsingInProcessMedia() const;
+#endif
 
   // Quick reference for initialization order:
   // Constructor
diff --git a/content/browser/gpu/gpu_data_manager_impl_private.cc b/content/browser/gpu/gpu_data_manager_impl_private.cc
index 87bad09..2188d1c 100644
--- a/content/browser/gpu/gpu_data_manager_impl_private.cc
+++ b/content/browser/gpu/gpu_data_manager_impl_private.cc
@@ -644,6 +644,15 @@ void GpuDataManagerImplPrivate::AppendGpuCommandLine(
   } else if (!use_gl.empty()) {
     command_line->AppendSwitchASCII(switches::kUseGL, use_gl);
   }
+#if defined(USE_GSTREAMER)
+  else {
+    // TODO: use kGLImplementationEGLName (egl/gles2, --use-gl=egl)
+    // Set to default for now (i.e. glx, --use-gl=desktop).
+    command_line->AppendSwitchASCII(switches::kUseGL,
+                                    gfx::kGLImplementationDesktopName);
+  }
+#endif
+
   if (ui::GpuSwitchingManager::GetInstance()->SupportsDualGpus())
     command_line->AppendSwitchASCII(switches::kSupportsDualGpus, "true");
   else
diff --git a/content/browser/media/media_data_manager_impl.cc b/content/browser/media/media_data_manager_impl.cc
new file mode 100644
index 0000000..446fb07
--- /dev/null
+++ b/content/browser/media/media_data_manager_impl.cc
@@ -0,0 +1,78 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/browser/media/media_data_manager_impl.h"
+
+#include "content/browser/media/media_data_manager_impl_private.h"
+
+namespace content {
+
+// static
+MediaDataManager* MediaDataManager::GetInstance() {
+  return MediaDataManagerImpl::GetInstance();
+}
+
+// static
+MediaDataManagerImpl* MediaDataManagerImpl::GetInstance() {
+  return Singleton<MediaDataManagerImpl>::get();
+}
+
+void MediaDataManagerImpl::GetMediaProcessHandles(
+    const GetMediaProcessHandlesCallback& callback) const {
+  base::AutoLock auto_lock(lock_);
+  private_->GetMediaProcessHandles(callback);
+}
+
+void MediaDataManagerImpl::AddObserver(MediaDataManagerObserver* observer) {
+  base::AutoLock auto_lock(lock_);
+  private_->AddObserver(observer);
+}
+
+void MediaDataManagerImpl::RemoveObserver(MediaDataManagerObserver* observer) {
+  base::AutoLock auto_lock(lock_);
+  private_->RemoveObserver(observer);
+}
+
+void MediaDataManagerImpl::Initialize() {
+  base::AutoLock auto_lock(lock_);
+  private_->Initialize();
+}
+
+// TODO: check unused code
+void MediaDataManagerImpl::AppendRendererCommandLine(
+    base::CommandLine* command_line) const {
+  base::AutoLock auto_lock(lock_);
+  private_->AppendRendererCommandLine(command_line);
+}
+
+void MediaDataManagerImpl::AppendMediaCommandLine(
+    base::CommandLine* command_line) const {
+  base::AutoLock auto_lock(lock_);
+  private_->AppendMediaCommandLine(command_line);
+}
+
+void MediaDataManagerImpl::AddLogMessage(int level,
+                                         const std::string& header,
+                                         const std::string& message) {
+  base::AutoLock auto_lock(lock_);
+  private_->AddLogMessage(level, header, message);
+}
+
+void MediaDataManagerImpl::ProcessCrashed(base::TerminationStatus exit_code) {
+  base::AutoLock auto_lock(lock_);
+  private_->ProcessCrashed(exit_code);
+}
+
+// TODO: check unused code
+base::ListValue* MediaDataManagerImpl::GetLogMessages() const {
+  base::AutoLock auto_lock(lock_);
+  return private_->GetLogMessages();
+}
+
+MediaDataManagerImpl::MediaDataManagerImpl()
+    : private_(MediaDataManagerImplPrivate::Create(this)) {}
+
+MediaDataManagerImpl::~MediaDataManagerImpl() {}
+
+}  // namespace content
diff --git a/content/browser/media/media_data_manager_impl.h b/content/browser/media/media_data_manager_impl.h
new file mode 100644
index 0000000..1ff1456
--- /dev/null
+++ b/content/browser/media/media_data_manager_impl.h
@@ -0,0 +1,96 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_BROWSER_MEDIA_MEDIA_DATA_MANAGER_IMPL_H_
+#define CONTENT_BROWSER_MEDIA_MEDIA_DATA_MANAGER_IMPL_H_
+
+#include <string>
+
+#include "base/compiler_specific.h"
+#include "base/files/file_path.h"
+#include "base/logging.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/singleton.h"
+#include "base/process/kill.h"
+#include "base/synchronization/lock.h"
+#include "base/time/time.h"
+#include "base/values.h"
+#include "content/public/browser/media_data_manager.h"
+
+namespace base {
+class CommandLine;
+}
+
+namespace content {
+
+class MediaDataManagerImplPrivate;
+struct WebPreferences;
+
+class CONTENT_EXPORT MediaDataManagerImpl
+    : public NON_EXPORTED_BASE(MediaDataManager) {
+ public:
+  // Getter for the singleton. This will return NULL on failure.
+  static MediaDataManagerImpl* GetInstance();
+
+  // MediaDataManager implementation.
+  void GetMediaProcessHandles(
+      const GetMediaProcessHandlesCallback& callback) const override;
+
+  // TODO: useful for stats but unused for now.
+  void AddObserver(MediaDataManagerObserver* observer) override;
+  void RemoveObserver(MediaDataManagerObserver* observer) override;
+
+  void Initialize();
+
+  // Insert disable-feature switches corresponding to preliminary media feature
+  // flags into the renderer process command line.
+  void AppendRendererCommandLine(base::CommandLine* command_line) const;
+
+  // Insert switches into media process command line: XXXX, etc.
+  void AppendMediaCommandLine(base::CommandLine* command_line) const;
+
+  void AddLogMessage(int level,
+                     const std::string& header,
+                     const std::string& message);
+
+  void ProcessCrashed(base::TerminationStatus exit_code);
+
+  // Returns a new copy of the ListValue.  Caller is responsible to release
+  // the returned value.
+  base::ListValue* GetLogMessages() const;
+
+ private:
+  friend class MediaDataManagerImplPrivate;
+  friend struct DefaultSingletonTraits<MediaDataManagerImpl>;
+
+  class UnlockedSession {
+   public:
+    explicit UnlockedSession(MediaDataManagerImpl* owner) : owner_(owner) {
+      DCHECK(owner_);
+      owner_->lock_.AssertAcquired();
+      owner_->lock_.Release();
+    }
+
+    ~UnlockedSession() {
+      DCHECK(owner_);
+      owner_->lock_.Acquire();
+    }
+
+   private:
+    MediaDataManagerImpl* owner_;
+    DISALLOW_COPY_AND_ASSIGN(UnlockedSession);
+  };
+
+  MediaDataManagerImpl();
+  ~MediaDataManagerImpl() override;
+
+  mutable base::Lock lock_;
+  scoped_ptr<MediaDataManagerImplPrivate> private_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaDataManagerImpl);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_BROWSER_MEDIA_MEDIA_DATA_MANAGER_IMPL_H_
diff --git a/content/browser/media/media_data_manager_impl_private.cc b/content/browser/media/media_data_manager_impl_private.cc
new file mode 100644
index 0000000..bb4dc7a
--- /dev/null
+++ b/content/browser/media/media_data_manager_impl_private.cc
@@ -0,0 +1,118 @@
+// Copyright (c) 2013 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/browser/media/media_data_manager_impl_private.h"
+
+#include "base/bind.h"
+#include "base/bind_helpers.h"
+#include "base/command_line.h"
+#include "base/metrics/field_trial.h"
+#include "base/metrics/histogram.h"
+#include "base/metrics/sparse_histogram.h"
+#include "base/strings/string_number_conversions.h"
+#include "base/strings/stringprintf.h"
+#include "base/sys_info.h"
+#include "base/trace_event/trace_event.h"
+#include "base/version.h"
+#include "cc/base/switches.h"
+#include "content/browser/media/media_process_host.h"
+#include "content/common/media/media_messages.h"
+#include "content/public/browser/browser_thread.h"
+#include "content/public/browser/media_data_manager_observer.h"
+#include "content/public/common/content_client.h"
+#include "content/public/common/content_constants.h"
+#include "content/public/common/content_switches.h"
+#include "content/public/common/web_preferences.h"
+
+namespace content {
+
+void MediaDataManagerImplPrivate::GetMediaProcessHandles(
+    const MediaDataManager::GetMediaProcessHandlesCallback& callback) const {
+  MediaProcessHost::GetProcessHandles(callback);
+}
+
+void MediaDataManagerImplPrivate::AddObserver(
+    MediaDataManagerObserver* observer) {
+  MediaDataManagerImpl::UnlockedSession session(owner_);
+  observer_list_->AddObserver(observer);
+}
+
+void MediaDataManagerImplPrivate::RemoveObserver(
+    MediaDataManagerObserver* observer) {
+  MediaDataManagerImpl::UnlockedSession session(owner_);
+  observer_list_->RemoveObserver(observer);
+}
+
+void MediaDataManagerImplPrivate::Initialize() {}
+
+void MediaDataManagerImplPrivate::AppendRendererCommandLine(
+    base::CommandLine* command_line) const {
+  DCHECK(command_line);
+  // command_line->AppendSwitch(switches::kXXXX);
+}
+
+void MediaDataManagerImplPrivate::AppendMediaCommandLine(
+    base::CommandLine* command_line) const {
+  DCHECK(command_line);
+  // command_line->AppendSwitch(switches::kXXXX);
+}
+
+void MediaDataManagerImplPrivate::AddLogMessage(int level,
+                                                const std::string& header,
+                                                const std::string& message) {
+  log_messages_.push_back(LogMessage(level, header, message));
+}
+
+void MediaDataManagerImplPrivate::ProcessCrashed(
+    base::TerminationStatus exit_code) {
+  if (!BrowserThread::CurrentlyOn(BrowserThread::UI)) {
+    // Unretained is ok, because it's posted to UI thread, the thread
+    // where the singleton GpuDataManagerImpl lives until the end.
+    BrowserThread::PostTask(BrowserThread::UI, FROM_HERE,
+                            base::Bind(&MediaDataManagerImpl::ProcessCrashed,
+                                       base::Unretained(owner_), exit_code));
+    return;
+  }
+}
+
+base::ListValue* MediaDataManagerImplPrivate::GetLogMessages() const {
+  base::ListValue* value = new base::ListValue;
+  for (size_t ii = 0; ii < log_messages_.size(); ++ii) {
+    base::DictionaryValue* dict = new base::DictionaryValue();
+    dict->SetInteger("level", log_messages_[ii].level);
+    dict->SetString("header", log_messages_[ii].header);
+    dict->SetString("message", log_messages_[ii].message);
+    value->Append(dict);
+  }
+  return value;
+}
+
+// static
+MediaDataManagerImplPrivate* MediaDataManagerImplPrivate::Create(
+    MediaDataManagerImpl* owner) {
+  return new MediaDataManagerImplPrivate(owner);
+}
+
+MediaDataManagerImplPrivate::MediaDataManagerImplPrivate(
+    MediaDataManagerImpl* owner)
+    : observer_list_(new MediaDataManagerObserverList),
+      owner_(owner),
+      finalized_(false) {
+  DCHECK(owner_);
+  /*
+    const base::CommandLine* command_line =
+        base::CommandLine::ForCurrentProcess();
+
+    if (command_line->HasSwitch(switches::kXXXX))
+      DoSomething();
+  */
+}
+
+MediaDataManagerImplPrivate::~MediaDataManagerImplPrivate() {}
+
+void MediaDataManagerImplPrivate::OnMediaProcessInitFailure() {
+  // TODO: implement
+}
+
+}  // namespace content
diff --git a/content/browser/media/media_data_manager_impl_private.h b/content/browser/media/media_data_manager_impl_private.h
new file mode 100644
index 0000000..4b0ba00
--- /dev/null
+++ b/content/browser/media/media_data_manager_impl_private.h
@@ -0,0 +1,83 @@
+// Copyright (c) 2013 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_BROWSER_MEDIA_MEDIA_DATA_MANAGER_IMPL_PRIVATE_H_
+#define CONTENT_BROWSER_MEDIA_MEDIA_DATA_MANAGER_IMPL_PRIVATE_H_
+
+#include <list>
+#include <map>
+#include <set>
+#include <string>
+#include <vector>
+
+#include "base/memory/ref_counted.h"
+#include "base/memory/singleton.h"
+#include "base/observer_list_threadsafe.h"
+#include "content/common/content_export.h"
+#include "content/public/browser/media_data_manager.h"
+#include "content/public/browser/media_data_manager_observer.h"
+#include "content/browser/media/media_data_manager_impl.h"
+#include "content/browser/media/media_data_manager_impl_private.h"
+
+namespace base {
+class CommandLine;
+}
+
+namespace content {
+
+class CONTENT_EXPORT MediaDataManagerImplPrivate {
+ public:
+  static MediaDataManagerImplPrivate* Create(MediaDataManagerImpl* owner);
+
+  void GetMediaProcessHandles(
+      const MediaDataManager::GetMediaProcessHandlesCallback& callback) const;
+  void AddObserver(MediaDataManagerObserver* observer);
+  void RemoveObserver(MediaDataManagerObserver* observer);
+
+  void Initialize();
+  void AppendRendererCommandLine(base::CommandLine* command_line) const;
+  void AppendMediaCommandLine(base::CommandLine* command_line) const;
+
+  void AddLogMessage(int level,
+                     const std::string& header,
+                     const std::string& message);
+
+  void ProcessCrashed(base::TerminationStatus exit_code);
+
+  base::ListValue* GetLogMessages() const;
+  void OnMediaProcessInitFailure();
+
+  virtual ~MediaDataManagerImplPrivate();
+
+ private:
+  typedef base::ObserverListThreadSafe<MediaDataManagerObserver>
+      MediaDataManagerObserverList;
+
+  struct LogMessage {
+    int level;
+    std::string header;
+    std::string message;
+
+    LogMessage(int _level,
+               const std::string& _header,
+               const std::string& _message)
+        : level(_level), header(_header), message(_message) {}
+  };
+
+  explicit MediaDataManagerImplPrivate(MediaDataManagerImpl* owner);
+  const scoped_refptr<MediaDataManagerObserverList> observer_list_;
+
+  std::vector<LogMessage> log_messages_;
+
+  MediaDataManagerImpl* owner_;
+
+  // True if all future Initialize calls should be ignored.
+  bool finalized_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaDataManagerImplPrivate);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_BROWSER_GPU_GPU_DATA_MANAGER_IMPL_PRIVATE_H_
